#ifndef _ALARM_EVENT_UPLOAD_H_
#define _ALARM_EVENT_UPLOAD_H_

#include "linkface_sdk_v2.h"

#if defined(__cplusplus) /* If this is a C++ compiler, use C linkage */
extern "C"
{
#endif

typedef enum __tag_alarm_type
{
    LINKFACE_ALARMTYPE_MATCHED = 10007,
    LINKFACE_ALARMTYPE_DETECTED = 10008
}LINKFACE_ALARM_TYPE_E;

typedef struct __tag_intelligent_event
{
    int alarmType;          // 告警类型 LINKFACE_ALARM_TYPE_E
    int alarmPicSize;       // 告警图片大小
    char eventTime[24];     // 告警产生时间(UTC时间,毫秒)
    char alarmPicId[128];   // 告警图片ID
    char data[1024];        // 告警内容
}INTELLIGENT_EVENT_ST;

typedef struct __tag_intelligent_event_list
{
    struct  list_head       event_list;
    INTELLIGENT_EVENT_ST    stEvent;
}INTELLIGENT_EVENT_LIST_ST;


int new_post_event_task(linkface_match_result *result, char *pfilePath);

int init_post_event_task(int task_count);

int deinit_post_event_task();

int upload_intelligent_event();

/*
 * 增加告警引用计数
 */
void alarm_event_post_task_increase_AlarmCount();
/*
 * 减少告警引用计数
 */
void alarm_event_post_task_decrease_AlarmCount();
/*
 * 获取告警引用计数
 */
int alarm_event_post_task_get_AlarmCount();

#if defined(__cplusplus) /* If this is a C++ compiler, use C linkage */
}
#endif


#endif

